--@Author: Alex2009, Sven777b
--@Web: www.ls-landtechnik.de, www.alex2009.de

-- Basis fr eigene "Placeables" by Alex2009 & Sven777b, Spezifikation "PlaceableTipTrigger" by rafftnix (February 2013) Erlaubnis dafr von Sven777b erhalten.
-- Anpassungen fr Platzierbares Feuer by Grisu118


PlaceableFire = {};
PlaceableFire_mt = Class(PlaceableFire, Placeable);
InitObjectClass(PlaceableFire, "PlaceableFire");

function PlaceableFire:new(isServer, isClient, customMt)
    local self = Placeable:new(isServer, isClient, PlaceableFire_mt);
    registerObjectClassName(self, "PlaceableFire");
	--g_currentMission:addTipTrigger(self);
    return self;
end;

function PlaceableFire:delete()
	
	Utils.deleteParticleSystem(self.particleSystems);
	
   
    unregisterObjectClassName(self);
    PlaceableFire:superClass().delete(self);
end;

function PlaceableFire:deleteFinal()
    PlaceableFire:superClass().deleteFinal(self);
end;

function PlaceableFire:load(xmlFilename, x,y,z, rx,ry,rz, moveMode, initRandom)
	
    if not PlaceableFire:superClass().load(self, xmlFilename, x,y,z, rx,ry,rz, moveMode, initRandom) then
        return false;
    end;
	
    if not moveMode then
		local xmlFile = loadXMLFile("TempXML", xmlFilename);
		self.Hinweis = Utils.indexToObject(self.nodeId, getXMLString(xmlFile, "placeable.Hinweis#index"));
		--PS
		self.particleSystems = {};
		local i = 0;
		while true do
			local ps = string.format("placeable.particleSystems.system(%d)", i);
			local index = Utils.indexToObject(self.nodeId, getXMLString(xmlFile, ps .. "#index"));
			if index == nil then
				break;
			end; 
			Utils.loadParticleSystem(xmlFile, self.particleSystems, ps, index, false, nil, self.baseDirectory)		
			i = i +1;		
		end;
		Utils.setEmittingState(self.particleSystems, true);
		setVisibility(self.Hinweis, false);
		delete(xmlFile);
	end;
    return true;
end;

function PlaceableFire:readStream(streamId, connection)
	PlaceableFire:superClass().readStream(self, streamId, connection);
	
end;

function PlaceableFire:writeStream(streamId, connection)
	PlaceableFire:superClass().writeStream(self, streamId, connection)
	
end;

function PlaceableFire:readUpdateStream(streamId, timestamp, connection)
	PlaceableFire:superClass().readUpdateStream(self, streamId, timestamp, connection);
end;	
  
function PlaceableFire:writeUpdateStream(streamId, connection, dirtyMask)
	PlaceableFire:superClass().writeUpdateStream(self, streamId, connection, dirtyMask);
	
end;
 
function PlaceableFire:update(dt)
	
end;

function PlaceableFire:updateMoving(delta)
	
end;

function PlaceableFire:updateTrailerTipping(trailer, fillDelta, fillType)
	
end;

function PlaceableFire:getTipInfoForTrailer(trailer, tipReferencePointIndex)
	
end;

function PlaceableFire:getTipDistanceFromTrailer(trailer, tipReferencePointIndex)
	
end;

function PlaceableFire:getNoAllowedText(trailer)
	
end;

function PlaceableFire:triggerCallback(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
	
end;

registerPlaceableType("PlaceableFire", PlaceableFire);